unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RVTable, RVStyle, RVScroll, RichView, RVEdit, Clipbrd;

const WM_MOVETOFIELD = WM_USER+5;

type
  TForm1 = class(TForm)
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    procedure FormCreate(Sender: TObject);
    procedure RichViewEdit1Change(Sender: TObject);
    procedure RichViewEdit1Paste(Sender: TCustomRichViewEdit;
      var DoDefault: Boolean);
  private
    { Private declarations }
    table: TRVTableItemInfo;
    procedure WMMoveToField(var Msg: TMessage); message WM_MOVETOFIELD;
    procedure TableCellEditing(Sender: TRVTableItemInfo;
      Row, Col : Integer; Automatic: Boolean; var AllowEdit: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);

begin
   RVStyle1.ParaStyles[0].Options := [rvpaoNoWrap, rvpaoReadOnly];
   RVStyle1.ParaStyles[1].Options := [rvpaoNoWrap];
   RVStyle1.SpacesInTab := 8;

   RichViewEdit1.EditorOptions := RichViewEdit1.EditorOptions+[rvoDoNotWantReturns];
   RichViewEdit1.AcceptDragDropFormats := [];
   RichViewEdit1.Color := clInfoBk;

   table := TRVTableItemInfo.CreateEx(2,2, RichViewEdit1.RVData);
   table.BestWidth := 200;
   table.Cells[0,0].Clear;
   table.Cells[0,1].Clear;
   table.Cells[1,0].Clear;
   table.Cells[1,1].Clear;
   table.Cells[0,0].AddNL('First name:', 0, 0);
   table.Cells[0,1].AddNL('', 1, 1);
   table.Cells[1,0].AddNL('Last name:', 0, 0);
   table.Cells[1,1].AddNL('', 1, 1);
   table.CellBorderWidth := 1;
   table.CellBorderStyle := rvtbColor;
   table.Cells[0,0].VisibleBorders.SetAll(False);
   table.Cells[1,0].VisibleBorders.SetAll(False);
   table.Cells[0,1].Color := clWindow;
   table.Cells[1,1].Color := clWindow;
   table.Color := clNone;
   table.Options := table.Options + [rvtoHideGridLines, rvtoIgnoreContentWidth];
   RichViewEdit1.Clear;
   RichViewEdit1.AddItem('', table);
   table.OnCellEditing := TableCellEditing;
   RichViewEdit1.Format;
   table.EditCell(0,1);
end;

procedure TForm1.TableCellEditing(Sender: TRVTableItemInfo; Row,
  Col: Integer; Automatic: Boolean; var AllowEdit: Boolean);
begin
  // We cannot initialize editing of another cell in this event
  // So we use PostMessage
  if Col=0 then
    PostMessage(Handle, WM_MOVETOFIELD, Row, 0);
end;

procedure TForm1.WMMoveToField(var Msg: TMessage);
begin
  table.EditCell(Msg.wParam, 1);
end;
  
procedure TForm1.RichViewEdit1Change(Sender: TObject);
begin
  // 10 characters max
  if (Length(table.Cells[0,1].GetRVData.GetItemText(0))>10) or
     (Length(table.Cells[1,1].GetRVData.GetItemText(0))>10) then begin
    RichViewEdit1.Undo;
    Beep;
  end;
end;

procedure TForm1.RichViewEdit1Paste(Sender: TCustomRichViewEdit;
  var DoDefault: Boolean);
var s: String;
    p: Integer;
begin
  // allowing pasting one line text only
  if Clipboard.HasFormat(CF_TEXT) then begin
    s := Clipboard.AsText;
    p := Pos(#13, s);
    if p>0 then
      s := Copy(s, 1, p-1);
    p := Pos(#10, s);
    if p>0 then
      s := Copy(s, 1, p-1);
    RichViewEdit1.InsertText(s, False);
  end;
  DoDefault := False;
end;

end.
